Attribute VB_Name = "Sample"
'====================================================================
' Axpad02s.bas
' AXP-AD02 荞ݎMTv
'====================================================================
Option Explicit

Public Const GWL_WNDPROC = -4
Public Const WM_USERMES = &H600
Public Const WM_AD02 = WM_USERMES + 100

Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hWnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Global lpPrevWndProc As Long
Global gHW As Long
Global wLogSocket As Integer
Global IrqCounter As Long
Global md As AD02_MODE          ' TvO[h
Global wBuff() As Integer       ' TvOf[^擾obt@

'====================================================================
' TuNXs
'====================================================================
Public Sub Hook()
    lpPrevWndProc = SetWindowLong(gHW, GWL_WNDPROC, AddressOf WindowProc)
End Sub
'====================================================================
' TuNX
'====================================================================
Public Sub Unhook()
    Dim temp As Long
    temp = SetWindowLong(gHW, GWL_WNDPROC, lpPrevWndProc)
End Sub
'--------------------------------------------------------------------
' EBhEbZ[W
'--------------------------------------------------------------------
Function WindowProc(ByVal hw As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Dim strbuf As String

    '----------------------------------------------------------------
    ' J[hbZ[W
    '----------------------------------------------------------------
    If uMsg = WM_AD02 + AD02_WM_OFS_CARD_REMOVAL Then
        OnREMOVAL (CInt(wParam))
        Exit Function
    End If
    '----------------------------------------------------------------
    ' EOC 荞݃bZ[W
    '----------------------------------------------------------------
    If uMsg = WM_AD02 + AD02_WM_OFS_EOC Then
        OnEOC (CInt(wParam))
        Exit Function
    End If
    '----------------------------------------------------------------
    ' HALF FULL 荞݃bZ[W
    '----------------------------------------------------------------
    If uMsg = WM_AD02 + AD02_WM_OFS_HALF_FULL Then
        OnHALFFULL (CInt(wParam))
        Exit Function
    End If
    '----------------------------------------------------------------
    ' OVERFLOW 荞݃bZ[W
    '----------------------------------------------------------------
    If uMsg = WM_AD02 + AD02_WM_OFS_OVERFLOW Then
        OnOVERFLOW (CInt(wParam))
        Exit Function
    End If
    '----------------------------------------------------------------
    ' OVERRUN 荞݃bZ[W
    '----------------------------------------------------------------
    If uMsg = WM_AD02 + AD02_WM_OFS_OVERRUN Then
        OnOVERRUN (CInt(wParam))
        Exit Function
    End If
    '----------------------------------------------------------------
    ' O͊荞݃bZ[W
    '----------------------------------------------------------------
    If uMsg = WM_AD02 + AD02_WM_OFS_EXIN Then
        OnEXIN (CInt(wParam))
        Exit Function
    End If
    '----------------------------------------------------------------
    ' ȊÕbZ[W̓ftHg̋s
    '----------------------------------------------------------------
    WindowProc = CallWindowProc(lpPrevWndProc, hw, uMsg, wParam, lParam)
End Function
'--------------------------------------------------------------------
' J[hbZ[W
'--------------------------------------------------------------------
Function OnREMOVAL(ByVal slot As Integer)
    IrqCounter = IrqCounter + 1
    ResultMessage ("J[hbZ[W")
End Function
'--------------------------------------------------------------------
' EOC 荞݃bZ[W
'--------------------------------------------------------------------
Function OnEOC(ByVal slot As Integer)
    IrqCounter = IrqCounter + 1
    ResultMessage ("EOC 荞݃bZ[W")
End Function
'--------------------------------------------------------------------
' HALF FULL 荞݃bZ[W
'--------------------------------------------------------------------
Function OnHALFFULL(ByVal slot As Integer)
    IrqCounter = IrqCounter + 1
    ResultMessage ("HALF FULL 荞݃bZ[W")
End Function
'--------------------------------------------------------------------
' OVERFLOW 荞݃bZ[W
'--------------------------------------------------------------------
Function OnOVERFLOW(ByVal slot As Integer)
    IrqCounter = IrqCounter + 1
    ResultMessage ("OVERFLOW 荞݃bZ[W")
End Function
'--------------------------------------------------------------------
' OVERRUN 荞݃bZ[W
'--------------------------------------------------------------------
Function OnOVERRUN(ByVal slot As Integer)
    IrqCounter = IrqCounter + 1
    ResultMessage ("OVERRUN 荞݃bZ[W")
End Function
'--------------------------------------------------------------------
' O͊ݏ
'--------------------------------------------------------------------
Function OnEXIN(ByVal slot As Integer)
    IrqCounter = IrqCounter + 1
    ResultMessage ("J[hbZ[W")
End Function
'--------------------------------------------------------------------
' ʂ\
'--------------------------------------------------------------------
Private Sub ResultMessage(lpszbuf As String)
    Form1.List1.AddItem (lpszbuf)
End Sub
'--------------------------------------------------------------------
' G[bZ[W\
'--------------------------------------------------------------------
Private Sub ErrorMessage(idx As Integer)
    
    Dim dwRes As Long
    Dim szBuf As String
    
    dwRes = Ad02wGetLastError(idx)

    Select Case dwRes
    Case AD02_ERR_WRAPDLL
        szBuf = "DLL Load error"

    Case Else                           ' ̑̒l̏ꍇB
        szBuf = "AXP-AD02 error" + Chr(10) + Chr(10) + _
                "Error code: &H" + _
                Hex(dwRes)
    End Select

    MsgBox szBuf, vbOKOnly + vbCritical
End Sub
'====================================================================
' 
'====================================================================
Public Sub OnLoad()
    Dim szBuf As String

    IrqCounter = 0
    '----------------------------------------------------------------
    ' DLL J
    '----------------------------------------------------------------
    If Ad02wDllOpen() = False Then
        ErrorMessage (AD02_SOCKET_AUTO)
        Exit Sub
    End If
    '----------------------------------------------------------------
    ' foCXgp錾
    '----------------------------------------------------------------
    wLogSocket = AD02_SOCKET_AUTO     ' gp̃foCXT܂B
    If Ad02wCreate(wLogSocket, gHW, WM_AD02, 0) = False Then
        ErrorMessage (AD02_SOCKET_AUTO)
        Exit Sub
    End If
    szBuf = "Ad02wCreate "
    ResultMessage (szBuf)
    '----------------------------------------------------------------
    ' TvO[hݒ
    '----------------------------------------------------------------
    md.cwBuffer = 10000
    md.dwChFirst = 0
    md.dwChLast = 0
    md.dwSampleMode = AD02_SM_CONTINUOUS
    md.dwTimer = 255
    md.dwTrigSource = AD02_TS_INTERNAL
    md.dwVoltageRange = AD02_VR_S10V

    If Ad02wSetMode(wLogSocket, md) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If

    szBuf = "Ad02wSetMode "
    ResultMessage (szBuf)
    '----------------------------------------------------------------
    ' TvOJn
    '----------------------------------------------------------------
    If Ad02wStartSampling(wLogSocket) = False Then
        ErrorMessage (wLogSocket)
        Exit Sub
    End If
    szBuf = "Ad02wStartSampling "
    ResultMessage (szBuf)
End Sub
'====================================================================
' I
'====================================================================
Public Sub OnUnLoad()
    '----------------------------------------------------------------
    ' TvO~
    '----------------------------------------------------------------
    If Ad02wStopSampling(wLogSocket) = True Then
        MsgBox "Ad02wStopSampling "
    End If
    '----------------------------------------------------------------
    ' foCX
    '----------------------------------------------------------------
    If Ad02wClose(wLogSocket) = True Then
        MsgBox "foCX܂"
    End If
    '----------------------------------------------------------------
    ' AD300.DLL 
    '----------------------------------------------------------------
    If Ad02wDllOpen = True Then
        MsgBox "DLL ܂"
    End If
End Sub

